// Header File
// Created 5/16/2005; 4:54:35 PM

#define d_UP				0
#define d_UPRIGHT		1
#define d_RIGHT			2
#define d_DOWNRIGHT	3
#define d_DOWN			4
#define d_DOWNLEFT	5
#define d_LEFT			6
#define d_UPLEFT		7

#define d_EXIT			-1
#define d_ENTER			-2

typedef struct
{
	int xLoc,yLoc;
	int xSquareSize,ySquareSize;
	int xDim,yDim;
} BOARDAREA;

void MessageBox(const char *title, const char *message, short left_button, short right_button)
{
	void *scrbackup=malloc(LCD_SIZE);
	short oldFont=FontGetSys();
	memcpy(scrbackup,LCD_MEM,LCD_SIZE);
	DlgMessage(title,message,left_button,right_button);
	memcpy(LCD_MEM,scrbackup,LCD_SIZE);
	FontSetSys(oldFont);
	free(scrbackup);
}

int writeFile(HSym theFile,void *ptr,unsigned long length)
{
	HANDLE *memBlock;
	char *dataPtr;
	if (theFile.folder==0) return 0;
	memBlock=&(DerefSym(theFile)->handle);
	*memBlock=HeapAlloc(length+10);
	dataPtr=HeapDeref(*memBlock);
	*((unsigned short*)dataPtr)=(unsigned short)length+7;
	dataPtr+=2;
	memcpy(dataPtr,ptr,length);
	dataPtr+=length;
	*(dataPtr++)=0;
	strcpy(dataPtr,"ObsS");
	dataPtr+=5;
	*dataPtr=DATA_TAG;
	return 1;
}

static ESQ typeOTH[2]={DATA_TAG,0};
const char *saveTypes={
	"Obsidio File"
};

void setFold(const char *folderName)
{
	if (!FolderCur(SYMSTR(folderName),TRUE))
	{
		FolderAdd(SYMSTR(folderName));
		FolderCur(SYMSTR(folderName),TRUE);
	}
}

HSym chooseSaveFile(void)
{
	void *scrbackup=malloc(LCD_SIZE);
	short oldFont=FontGetSys();
	char oldFolder[9];
	HSym ret;
	FolderGetCur(oldFolder);
	memcpy(scrbackup,LCD_MEM,LCD_SIZE);
	setFold("obsidio");
	ret=VarNew(typeOTH,saveTypes);
	FolderCur(SYMSTR(oldFolder),TRUE);
	memcpy(LCD_MEM,scrbackup,LCD_SIZE);
	FontSetSys(oldFont);
	free(scrbackup);
	return ret;
}

HSym chooseLoadFile(void)
{
	void *scrbackup=malloc(LCD_SIZE);
	short oldFont=FontGetSys();
	char oldFolder[9];
	HSym ret;
	FolderGetCur(oldFolder);
	memcpy(scrbackup,LCD_MEM,LCD_SIZE);
	setFold("obsidio");
	ret=VarOpen(typeOTH,saveTypes);
	FolderCur(SYMSTR(oldFolder),TRUE);
	memcpy(LCD_MEM,scrbackup,LCD_SIZE);
	FontSetSys(oldFont);
	free(scrbackup);
	return ret;
}

void *chooseFilePtr(void)
{
	HSym retH=chooseLoadFile();
	if (retH.folder==0) return NULL;
	return HeapDeref(DerefSym(retH)->handle)+2;
}

void ZeroMemory(void *destination,unsigned long length)
{
	memset(destination,0,length);
}

void DrawBox(int x0, int y0, int x1, int y1,int attr)
{
	DrawLine(x0,y0,x1-1,y0,attr);
	DrawLine(x1,y0,x1,y1-1,attr);
	DrawLine(x1,y1,x0+1,y1,attr);
	DrawLine(x0,y1,x0,y0+1,attr);
}

void FillBox(int x0, int y0, int x1, int y1,int attr)
{
	ScrRectFill(&(SCR_RECT){{x0, y0, x1, y1}},&(SCR_RECT){{0, 0, 239, 127}},attr);
}

BOARDAREA boardArea(int x0,int y0,int x1,int y1,int xDim,int yDim)
{
	BOARDAREA ret;
	int xdif=x1-x0,ydif=y1-y0;
	ret.xSquareSize=xdif/xDim;
	ret.xLoc=(xdif%xDim)/2+x0;
	ret.ySquareSize=ydif/yDim;
	ret.yLoc=(ydif%yDim)/2+y0;
	ret.xDim=xDim;
	ret.yDim=yDim;
	return ret;
}

void drawBoxAroundArea(BOARDAREA *theArea,int x,int y,int attr)
{
	int x0=theArea->xLoc+x*theArea->xSquareSize,y0=theArea->yLoc+y*theArea->ySquareSize;
	int x1=x0+theArea->xSquareSize,y1=y0+theArea->ySquareSize;
	DrawBox(x0-2,y0-2,x1+1,y1+1,attr);
}

short getArrowPress(void)
{
	short k;
	while (1)
	{
		k=ngetchx();
		if (k==KEY_ESC) return -1;
		if (k==KEY_UP) return d_UP;
		if (k==KEY_RIGHT) return d_RIGHT;
		if (k==KEY_DOWN) return d_DOWN;
		if (k==KEY_LEFT) return d_LEFT;
		if (k==KEY_ENTER) return d_ENTER;
	}
}

#include "mytiheader-mmenu.h"